import React, { forwardRef, useContext } from 'react';
import { IconContext } from '../lib/index.esm.js';
import { objectWithoutPropertiesLoose as _objectWithoutPropertiesLoose } from '../_virtual/_rollupPluginBabelHelpers.js';

var renderPathFor = function renderPathFor(weight, color) {
  switch (weight) {
    case "bold":
      return React.createElement(React.Fragment, null, React.createElement("polyline", {
        points: "192 104 152 104 152 64",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("line", {
        x1: "208",
        y1: "48",
        x2: "152",
        y2: "104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("polyline", {
        points: "64 152 104 152 104 192",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("line", {
        x1: "48",
        y1: "208",
        x2: "104",
        y2: "152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("polyline", {
        points: "152 192 152 152 192 152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("line", {
        x1: "208",
        y1: "208",
        x2: "152",
        y2: "152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("polyline", {
        points: "104 64 104 104 64 104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("line", {
        x1: "48",
        y1: "48",
        x2: "104",
        y2: "104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }));

    case "duotone":
      return React.createElement(React.Fragment, null, React.createElement("polyline", {
        points: "192 104 152 104 152 64",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "208",
        y1: "48",
        x2: "152",
        y2: "104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("polyline", {
        points: "64 152 104 152 104 192",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "48",
        y1: "208",
        x2: "104",
        y2: "152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("polyline", {
        points: "152 192 152 152 192 152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "208",
        y1: "208",
        x2: "152",
        y2: "152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("polyline", {
        points: "104 64 104 104 64 104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "48",
        y1: "48",
        x2: "104",
        y2: "104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }));

    case "fill":
      return React.createElement(React.Fragment, null, React.createElement("g", null, React.createElement("path", {
        d: "M144.04,104.79193c.01074.10773.03125.21222.0459.31867.02148.15216.03955.30456.06933.45544.02539.12622.06006.24841.09131.37244.03174.12921.06055.259.09912.38678.03711.12243.0835.2406.126.36047.04541.12659.0874.25385.13867.37848.0459.111.10059.21728.15137.32568.06006.12866.11719.25806.18506.384.05517.10279.11767.20032.17724.30036.07373.124.144.24921.22461.36993.07373.10968.15576.21259.23438.3183.07666.10358.14892.20947.23193.31006.14844.18091.30664.35321.47022.52032.02.0207.03711.0434.05761.06391.01612.01611.03418.02936.0503.04529.17138.16882.34912.33123.53564.48413.09424.07757.19385.145.291.21765.11181.08374.22168.17053.33789.24847.11474.07685.23388.14344.35156.21369.10644.06341.21045.13012.31934.18866.12011.06421.24365.11865.36621.17627.11425.054.22656.111.34375.15954.11816.049.23877.08844.35888.13141.12647.04547.25147.09393.38037.13312.12012.03619.2417.06268.36231.09314.13184.03326.26221.07019.39648.0968.14063.02789.28321.04456.42481.06482.1167.01666.231.03876.34912.05035.26221.02588.52588.03992.78955.03992h40a8,8,0,0,0,0-16H171.314l42.34327-42.34326a8.00018,8.00018,0,0,0-11.31446-11.31348L160,84.686V64a8,8,0,0,0-16,0v39.99487Q144,104.39405,144.04,104.79193Z"
      }), React.createElement("path", {
        d: "M111.96,151.20807c-.01074-.10773-.03125-.21222-.0459-.31867-.02148-.15216-.03955-.30456-.06933-.45544-.02539-.12622-.06006-.24841-.09131-.37244-.03174-.12921-.06055-.259-.09912-.38678-.03711-.12243-.0835-.2406-.126-.36047-.04541-.12659-.0874-.25385-.13867-.37848-.0459-.111-.10059-.21728-.15137-.32568-.06006-.12866-.11719-.25806-.18506-.384-.05517-.10279-.11767-.20032-.17724-.30036-.07373-.124-.144-.24921-.22461-.36993-.07373-.10968-.15576-.21259-.23438-.3183-.07666-.10358-.14892-.20947-.23193-.31006-.14844-.18091-.30664-.35321-.47022-.52032-.02-.0207-.03711-.0434-.05761-.06391-.01612-.01611-.03418-.02936-.0503-.04529-.17138-.16882-.34912-.33123-.53564-.48413-.09375-.07715-.19287-.14428-.28955-.21655-.11279-.08423-.22266-.17145-.33985-.24976-.11279-.07568-.23046-.14123-.34668-.21051-.10791-.06463-.21386-.1325-.32519-.1922-.1167-.06237-.23682-.11523-.356-.17144-.11767-.05579-.2334-.11444-.35449-.16455-.11377-.047-.22949-.08478-.34473-.12629-.13134-.04736-.26074-.09747-.395-.13806-.11377-.03436-.22949-.05938-.34423-.08862-.1377-.035-.27442-.07336-.41455-.10114-.13038-.02581-.26221-.04077-.39356-.06-.12695-.01862-.25195-.04236-.38086-.05494-.23193-.02282-.46484-.03271-.69824-.03527C104.05859,144.00415,104.02979,144,104,144H64a8,8,0,0,0,0,16H84.686L42.34277,202.34277a8.00053,8.00053,0,0,0,11.31446,11.31446L96,171.31409V192a8,8,0,0,0,16,0V152.00513Q112,151.606,111.96,151.20807Z"
      }), React.createElement("path", {
        d: "M171.314,160H192a8,8,0,0,0,0-16H152c-.02979,0-.05859.00415-.08838.00446-.2334.00256-.46631.01245-.69824.03527-.12891.01258-.25391.03632-.38086.05494-.13135.01928-.26318.03424-.39356.06-.14013.02778-.27685.06611-.41455.10114-.11474.02924-.23046.05426-.34423.08862-.13428.04059-.26368.0907-.395.13806-.11524.04151-.231.07929-.34473.12629-.12109.05011-.23682.10876-.35449.16455-.11914.05621-.23926.10907-.356.17144-.11133.0597-.21728.12757-.32519.1922-.11622.06928-.23389.13483-.34668.21051-.11719.07831-.22706.16553-.33985.24976-.09668.07227-.1958.1394-.28955.21655-.18652.1529-.36426.31531-.53564.48413-.01612.01593-.03418.02918-.0503.04529-.0205.02051-.03759.04321-.05761.06391-.16358.16711-.32178.33941-.47022.52032-.083.10059-.15527.20648-.23193.31006-.07862.10571-.16065.20862-.23438.3183-.08056.12072-.15088.24591-.22461.36993-.05957.1-.12207.19757-.17724.30036-.06787.12591-.125.25531-.18506.384-.05078.1084-.10547.21466-.15137.32568-.05127.12463-.09326.25189-.13867.37848-.04248.11987-.08887.238-.126.36047-.03857.12775-.06738.25757-.09912.38678-.03125.124-.06592.24622-.09131.37244-.02978.15088-.04785.30328-.06933.45544-.01465.10645-.03516.21094-.0459.31867q-.03956.39752-.04.79706V192a8,8,0,0,0,16,0V171.31409l42.34277,42.34314a8.00053,8.00053,0,0,0,11.31446-11.31446Z"
      }), React.createElement("path", {
        d: "M112,64a8,8,0,0,0-16,0V84.686L53.65723,42.34326A8.00018,8.00018,0,1,0,42.34277,53.65674L84.686,96H64a8,8,0,0,0,0,16h40c.26367,0,.52734-.014.78955-.03992.11816-.01159.23242-.03369.34912-.05035.1416-.02026.28418-.03693.42481-.06482.13427-.02661.26464-.06354.39648-.0968.12061-.03046.24219-.057.36231-.09314.1289-.03919.2539-.08765.38037-.13312.12011-.043.24072-.08246.35888-.13141.11719-.04858.2295-.10559.34375-.15954.12256-.05762.2461-.11206.36621-.17627.10889-.05854.2129-.12525.31934-.18866.11768-.07025.23682-.13684.35156-.21369.11621-.07794.22608-.16473.33789-.24847.09717-.07263.19678-.14008.291-.21765.18652-.1529.36426-.31531.53564-.48413.01612-.01593.03418-.02918.0503-.04529.0205-.02051.03759-.04321.05761-.06391.16358-.16711.32178-.33941.47022-.52032.083-.10059.15527-.20648.23193-.31006.07862-.10571.16065-.20862.23438-.3183.08056-.12072.15088-.24591.22461-.36993.05957-.1.12207-.19757.17724-.30036.06787-.12591.125-.25531.18506-.384.05078-.1084.10547-.21466.15137-.32568.05127-.12463.09326-.25189.13867-.37848.04248-.11987.08887-.238.126-.36047.03857-.12775.06738-.25757.09912-.38678.03125-.124.06592-.24622.09131-.37244.02978-.15088.04785-.30328.06933-.45544.01465-.10645.03516-.21094.0459-.31867q.03956-.39751.04-.79706Z"
      })));

    case "light":
      return React.createElement(React.Fragment, null, React.createElement("polyline", {
        points: "192 104 152 104 152 64",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("line", {
        x1: "208",
        y1: "48",
        x2: "152",
        y2: "104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("polyline", {
        points: "64 152 104 152 104 192",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("line", {
        x1: "48",
        y1: "208",
        x2: "104",
        y2: "152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("polyline", {
        points: "152 192 152 152 192 152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("line", {
        x1: "208",
        y1: "208",
        x2: "152",
        y2: "152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("polyline", {
        points: "104 64 104 104 64 104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("line", {
        x1: "48",
        y1: "48",
        x2: "104",
        y2: "104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }));

    case "thin":
      return React.createElement(React.Fragment, null, React.createElement("polyline", {
        points: "192 104 152 104 152 64",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("line", {
        x1: "208",
        y1: "48",
        x2: "152",
        y2: "104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("polyline", {
        points: "64 152 104 152 104 192",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("line", {
        x1: "48",
        y1: "208",
        x2: "104",
        y2: "152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("polyline", {
        points: "152 192 152 152 192 152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("line", {
        x1: "208",
        y1: "208",
        x2: "152",
        y2: "152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("polyline", {
        points: "104 64 104 104 64 104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("line", {
        x1: "48",
        y1: "48",
        x2: "104",
        y2: "104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }));

    case "regular":
      return React.createElement(React.Fragment, null, React.createElement("polyline", {
        points: "192 104 152 104 152 64",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "208",
        y1: "48",
        x2: "152",
        y2: "104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("polyline", {
        points: "64 152 104 152 104 192",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "48",
        y1: "208",
        x2: "104",
        y2: "152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("polyline", {
        points: "152 192 152 152 192 152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "208",
        y1: "208",
        x2: "152",
        y2: "152",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("polyline", {
        points: "104 64 104 104 64 104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "48",
        y1: "48",
        x2: "104",
        y2: "104",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }));

    default:
      console.error('Unsupported icon weight. Choose from "thin", "light", "regular", "bold", "fill", or "duotone".');
      return null;
  }
};

var ArrowsIn = /*#__PURE__*/forwardRef(function (props, ref) {
  var color = props.color,
      size = props.size,
      weight = props.weight,
      mirrored = props.mirrored,
      children = props.children,
      restProps = _objectWithoutPropertiesLoose(props, ["color", "size", "weight", "mirrored", "children"]);

  var _useContext = useContext(IconContext),
      contextColor = _useContext.color,
      contextSize = _useContext.size,
      contextWeight = _useContext.weight,
      contextMirrored = _useContext.mirrored,
      restContext = _objectWithoutPropertiesLoose(_useContext, ["color", "size", "weight", "mirrored"]);

  return React.createElement("svg", Object.assign({
    ref: ref,
    xmlns: "http://www.w3.org/2000/svg",
    width: size != null ? size : contextSize,
    height: size != null ? size : contextSize,
    fill: color != null ? color : contextColor,
    viewBox: "0 0 256 256",
    transform: mirrored || contextMirrored ? "scale(-1, 1)" : undefined
  }, restContext, restProps), children, React.createElement("rect", {
    width: "256",
    height: "256",
    fill: "none"
  }), renderPathFor(weight != null ? weight : contextWeight, color != null ? color : contextColor));
});
ArrowsIn.displayName = "ArrowsIn";

export default ArrowsIn;
//# sourceMappingURL=ArrowsIn.esm.js.map
