import React, { forwardRef, useContext } from 'react';
import { IconContext } from '../lib/index.esm.js';
import { objectWithoutPropertiesLoose as _objectWithoutPropertiesLoose } from '../_virtual/_rollupPluginBabelHelpers.js';

var renderPathFor = function renderPathFor(weight, color) {
  switch (weight) {
    case "bold":
      return React.createElement(React.Fragment, null, React.createElement("polyline", {
        points: "156.284 203.716 128 232 99.716 203.716",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("line", {
        x1: "128",
        y1: "160",
        x2: "128",
        y2: "232",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("polyline", {
        points: "99.716 52.284 128 24 156.284 52.284",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("line", {
        x1: "128",
        y1: "96",
        x2: "128",
        y2: "24",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("polyline", {
        points: "52.284 156.284 24 128 52.284 99.716",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("line", {
        x1: "96",
        y1: "128",
        x2: "24",
        y2: "128",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("polyline", {
        points: "203.716 99.716 232 128 203.716 156.284",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }), React.createElement("line", {
        x1: "160",
        y1: "128",
        x2: "232",
        y2: "128",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "24"
      }));

    case "duotone":
      return React.createElement(React.Fragment, null, React.createElement("polyline", {
        points: "156.284 203.716 128 232 99.716 203.716",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "128",
        y1: "160",
        x2: "128",
        y2: "232",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("polyline", {
        points: "99.716 52.284 128 24 156.284 52.284",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "128",
        y1: "96",
        x2: "128",
        y2: "24",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("polyline", {
        points: "52.284 156.284 24 128 52.284 99.716",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "96",
        y1: "128",
        x2: "24",
        y2: "128",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("polyline", {
        points: "203.716 99.716 232 128 203.716 156.284",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "160",
        y1: "128",
        x2: "232",
        y2: "128",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }));

    case "fill":
      return React.createElement(React.Fragment, null, React.createElement("g", null, React.createElement("path", {
        d: "M150.627,198.05859,136,212.686V160a8,8,0,0,0-16,0v52.686l-14.62695-14.62745a8.00036,8.00036,0,0,0-11.31446,11.314l28.28418,28.28418c.0459.0459.09668.08545.14356.12988.1416.13526.28369.269.43457.39356.06152.05078.12793.09423.19092.14306.144.11133.28808.22364.43945.3252.05127.03418.106.063.1582.09619.16846.10742.33838.21289.51514.3081.03711.02.07715.03565.11523.05518.19385.1001.39063.19629.59375.28076.02344.00977.04737.0166.07032.02588.21777.08789.43847.16895.66455.23779.02783.00879.05713.01368.085.022.2207.06445.44385.12353.67187.16894.0669.01319.13575.019.20313.03076.18945.03321.3789.06641.57226.08545a7.90223,7.90223,0,0,0,1.59864,0c.19336-.019.38281-.05224.57226-.08545.06738-.01172.13623-.01757.20313-.03076.228-.04541.45117-.10449.67187-.16894.02783-.0083.05713-.01319.085-.022.22608-.06884.44678-.1499.66455-.23779.02295-.00928.04688-.01611.07032-.02588.20312-.08447.3999-.18066.59375-.28076.03808-.01953.07812-.03516.11523-.05518.17676-.09521.34668-.20068.51514-.3081.05224-.0332.10693-.062.1582-.09619.15137-.10156.29541-.21387.43945-.3252.063-.04883.1294-.09228.19092-.14306.15088-.12452.293-.2583.43457-.39356.04688-.04443.09766-.084.14356-.12988l28.28418-28.28418a8.00036,8.00036,0,0,0-11.31446-11.314Z"
      }), React.createElement("path", {
        d: "M105.37305,57.94141,120,43.314V96a8,8,0,0,0,16,0V43.314L150.627,57.94141a8.00036,8.00036,0,0,0,11.31446-11.314L133.65723,18.34326c-.04151-.0415-.08789-.07715-.12989-.11767-.1455-.13965-.29248-.27784-.44824-.40577-.06152-.05078-.12793-.09423-.19092-.14306-.144-.11133-.28808-.22364-.43945-.3252-.05127-.03418-.106-.063-.1582-.09619-.16846-.10742-.33838-.21289-.51514-.3081-.0376-.02-.07764-.03614-.11621-.05567-.19336-.1001-.38965-.1958-.59229-.28027-.02587-.01074-.05224-.01807-.07812-.02832-.21533-.08692-.43359-.16748-.65723-.23535-.02783-.00879-.05713-.01368-.085-.022-.2207-.06445-.44385-.12353-.67187-.16894-.0669-.01319-.13575-.019-.20313-.03076-.18945-.03321-.3789-.06641-.57226-.08545a7.90223,7.90223,0,0,0-1.59864,0c-.19336.019-.38281.05224-.57226.08545-.06738.01172-.13623.01757-.20313.03076-.228.04541-.45117.10449-.67187.16894-.02783.0083-.05713.01319-.085.022-.22364.06787-.4419.14843-.65723.23535-.02588.01025-.05225.01758-.07812.02832-.20264.08447-.39893.18017-.59229.28027-.03857.01953-.07861.03565-.11621.05567-.17676.09521-.34668.20068-.51514.3081-.05224.0332-.10693.062-.1582.09619-.15137.10156-.29541.21387-.43945.3252-.063.04883-.1294.09228-.19092.14306-.15576.12793-.30274.26612-.44824.40577-.042.04052-.08838.07617-.12989.11767L94.05859,46.62744a8.00036,8.00036,0,0,0,11.31446,11.314Z"
      }), React.createElement("path", {
        d: "M43.31348,136H96a8,8,0,0,0,0-16H43.31348l14.62793-14.62744A8.00036,8.00036,0,0,0,46.627,94.05859L18.34277,122.34326c-.03076.03028-.05615.064-.08593.09522-.15284.15771-.30225.31836-.44141.48828-.08594.10449-.16113.21386-.24072.32129-.0752.102-.1543.20117-.2251.30664-.083.12353-.15479.252-.23.3789-.05762.09717-.11914.1919-.17236.29151-.06836.12744-.12647.25879-.1875.38916-.0503.10644-.10352.21142-.14893.3208-.05225.126-.09424.25439-.14014.38232-.042.11866-.08789.23584-.125.35694-.03857.12841-.06738.25879-.09961.38916-.03076.123-.06543.24511-.09082.3706-.02978.15137-.04834.3042-.06933.457-.01514.106-.03516.20948-.0459.3169a8.02276,8.02276,0,0,0,0,1.584c.01074.10742.03076.21094.0459.3169.021.15283.03955.30566.06933.457.02539.12549.06006.24756.09082.3706.03223.13037.061.26075.09961.38916.03711.1211.083.23828.125.35694.0459.12793.08789.25634.14014.38232.04541.10938.09863.21436.14893.3208.061.13037.11914.26172.1875.38916.05322.09961.11474.19434.17236.29151.07519.127.147.25537.23.3789.0708.10547.1499.20459.2251.30664.07959.10743.15478.2168.24072.32129.13672.16651.28369.32471.43311.47949.03271.03418.061.07081.09423.104L46.627,161.94141a8.00036,8.00036,0,0,0,11.31446-11.314Z"
      }), React.createElement("path", {
        d: "M238.18457,133.07324c.08594-.10449.16113-.21386.24072-.32129.0752-.102.1543-.20117.2251-.30664.083-.12353.15479-.25195.23-.3789.05762-.09717.11914-.1919.17236-.29151.06836-.12744.12647-.25879.1875-.38916.0503-.10644.10352-.21142.14893-.3208.05225-.126.09424-.25439.14014-.38232.042-.11866.08789-.23584.125-.35694.03857-.12841.06738-.25879.09961-.38916.03076-.123.06543-.24511.09082-.3706.02978-.15137.04834-.3042.06933-.457.01514-.106.03516-.20948.0459-.3169a8.02276,8.02276,0,0,0,0-1.584c-.01074-.10742-.03076-.21094-.0459-.3169-.021-.15283-.03955-.30566-.06933-.457-.02539-.12549-.06006-.24756-.09082-.3706-.03223-.13037-.061-.26075-.09961-.38916-.03711-.1211-.083-.23828-.125-.35694-.0459-.12793-.08789-.25634-.14014-.38232-.04541-.10938-.09863-.21436-.14893-.3208-.061-.13037-.11914-.26172-.1875-.38916-.05322-.09961-.11474-.19434-.17236-.29151-.07519-.12695-.147-.25537-.23-.3789-.0708-.10547-.1499-.20459-.2251-.30664-.07959-.10743-.15478-.2168-.24072-.32129-.13916-.16992-.28857-.33057-.44141-.48828-.02978-.03125-.05517-.06494-.08593-.09522L209.37305,94.05859a8.00036,8.00036,0,0,0-11.31446,11.314L212.68652,120H160a8,8,0,0,0,0,16h52.68652l-14.62793,14.62744a8.00036,8.00036,0,0,0,11.31446,11.314l28.28418-28.28467c.0332-.0332.06152-.06983.09423-.104C237.90088,133.398,238.04785,133.23975,238.18457,133.07324Z"
      })));

    case "light":
      return React.createElement(React.Fragment, null, React.createElement("polyline", {
        points: "156.284 203.716 128 232 99.716 203.716",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("line", {
        x1: "128",
        y1: "160",
        x2: "128",
        y2: "232",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("polyline", {
        points: "99.716 52.284 128 24 156.284 52.284",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("line", {
        x1: "128",
        y1: "96",
        x2: "128",
        y2: "24",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("polyline", {
        points: "52.284 156.284 24 128 52.284 99.716",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("line", {
        x1: "96",
        y1: "128",
        x2: "24",
        y2: "128",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("polyline", {
        points: "203.716 99.716 232 128 203.716 156.284",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }), React.createElement("line", {
        x1: "160",
        y1: "128",
        x2: "232",
        y2: "128",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "12"
      }));

    case "thin":
      return React.createElement(React.Fragment, null, React.createElement("polyline", {
        points: "156.284 203.716 128 232 99.716 203.716",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("line", {
        x1: "128",
        y1: "160",
        x2: "128",
        y2: "232",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("polyline", {
        points: "99.716 52.284 128 24 156.284 52.284",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("line", {
        x1: "128",
        y1: "96",
        x2: "128",
        y2: "24",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("polyline", {
        points: "52.284 156.284 24 128 52.284 99.716",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("line", {
        x1: "96",
        y1: "128",
        x2: "24",
        y2: "128",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("polyline", {
        points: "203.716 99.716 232 128 203.716 156.284",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }), React.createElement("line", {
        x1: "160",
        y1: "128",
        x2: "232",
        y2: "128",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "8"
      }));

    case "regular":
      return React.createElement(React.Fragment, null, React.createElement("polyline", {
        points: "156.284 203.716 128 232 99.716 203.716",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "128",
        y1: "160",
        x2: "128",
        y2: "232",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("polyline", {
        points: "99.716 52.284 128 24 156.284 52.284",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "128",
        y1: "96",
        x2: "128",
        y2: "24",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("polyline", {
        points: "52.284 156.284 24 128 52.284 99.716",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "96",
        y1: "128",
        x2: "24",
        y2: "128",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("polyline", {
        points: "203.716 99.716 232 128 203.716 156.284",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }), React.createElement("line", {
        x1: "160",
        y1: "128",
        x2: "232",
        y2: "128",
        fill: "none",
        stroke: color,
        strokeLinecap: "round",
        strokeLinejoin: "round",
        strokeWidth: "16"
      }));

    default:
      console.error('Unsupported icon weight. Choose from "thin", "light", "regular", "bold", "fill", or "duotone".');
      return null;
  }
};

var ArrowsOutCardinal = /*#__PURE__*/forwardRef(function (props, ref) {
  var color = props.color,
      size = props.size,
      weight = props.weight,
      mirrored = props.mirrored,
      children = props.children,
      restProps = _objectWithoutPropertiesLoose(props, ["color", "size", "weight", "mirrored", "children"]);

  var _useContext = useContext(IconContext),
      contextColor = _useContext.color,
      contextSize = _useContext.size,
      contextWeight = _useContext.weight,
      contextMirrored = _useContext.mirrored,
      restContext = _objectWithoutPropertiesLoose(_useContext, ["color", "size", "weight", "mirrored"]);

  return React.createElement("svg", Object.assign({
    ref: ref,
    xmlns: "http://www.w3.org/2000/svg",
    width: size != null ? size : contextSize,
    height: size != null ? size : contextSize,
    fill: color != null ? color : contextColor,
    viewBox: "0 0 256 256",
    transform: mirrored || contextMirrored ? "scale(-1, 1)" : undefined
  }, restContext, restProps), children, React.createElement("rect", {
    width: "256",
    height: "256",
    fill: "none"
  }), renderPathFor(weight != null ? weight : contextWeight, color != null ? color : contextColor));
});
ArrowsOutCardinal.displayName = "ArrowsOutCardinal";

export default ArrowsOutCardinal;
//# sourceMappingURL=ArrowsOutCardinal.esm.js.map
