import { ComponentPropsWithoutRef } from "react";
export interface IconProps extends ComponentPropsWithoutRef<"svg"> {
    color?: string;
    size?: string | number;
    weight?: "thin" | "light" | "regular" | "bold" | "fill" | "duotone";
    mirrored?: boolean;
}
export declare type Icon = React.ForwardRefExoticComponent<IconProps & React.RefAttributes<SVGSVGElement>>;
export declare type IconContextProps = Required<Pick<IconProps, "color" | "size" | "weight" | "mirrored">> & ComponentPropsWithoutRef<"svg">;
export declare const IconContext: import("react").Context<IconContextProps>;
